package com.yingxin.beijingvehicleflow.controller;

import com.yingxin.beijingvehicleflow.constant.Const;
import com.yingxin.beijingvehicleflow.entity.FloatingPopulation;
import com.yingxin.beijingvehicleflow.entity.IdentityInformation;
import com.yingxin.beijingvehicleflow.response.Response;
import com.yingxin.beijingvehicleflow.service.FloatingPopulationServcie;
import com.yingxin.beijingvehicleflow.util.DesUtil;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.SimpleDateFormat;
import java.util.Date;


/**
 * description //TODO
 *
 * @author 226
 * @version 1.0
 * @date 2020/2/24
 */
@RestController
@CrossOrigin
@RequestMapping("/api/v1")
public class FloatingPopulationController {

    private static Logger LOGGER = LoggerFactory.getLogger(FloatingPopulationController.class);


    @Autowired
    private FloatingPopulationServcie populationServcie;

    @PostMapping("/float-population")
    public Response checkFloatingPopulation(@RequestBody String json) {

        IdentityInformation info;
        JSONObject datafterDecryptJson;
        try {
            JSONObject jsonObject = JSONObject.fromObject(json);
            String encodedData = jsonObject.getString("encodedData");
            String datafterDecryptStr = DesUtil.decrypt(Const.KEY, encodedData);
            datafterDecryptJson = JSONObject.fromObject(datafterDecryptStr);
        } catch (Exception e) {
            LOGGER.error("json解析异常", e);
            return Response.fail();
        }

        FloatingPopulation floatingPopulation = new FloatingPopulation();
        floatingPopulation.setAuthTime(datafterDecryptJson.getString("authTime"));
        floatingPopulation.setAuthCoordinate(datafterDecryptJson.getString("authCoordinate"));
        floatingPopulation.setReservationId(datafterDecryptJson.getInt("id"));

        if (!populationServcie.isIdentityInfoValid(floatingPopulation)) {
            return Response.fail("INVALID-CODE","二维码已过期，请重新生成二维码。");
        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        floatingPopulation.setCheckTime(sdf.format(new Date()));
        FloatingPopulation selectResult = populationServcie.selectOneByReservationId(floatingPopulation);
        floatingPopulation.setAuthCoordinate(selectResult.getAuthCoordinate());
        floatingPopulation.setAuthTime(selectResult.getAuthTime());
        floatingPopulation.setSubmitCoordinate(selectResult.getSubmitCoordinate());
        floatingPopulation.setSubmitTime(selectResult.getSubmitTime());

        return populationServcie.isInsertFloatingPopulationSucc(floatingPopulation)?Response.succ():Response.fail();
    }


}
